#!/usr/local/bin/perl

print <<EOM;
% LaTeX, please!
%
% Note that using "dvips" with landscape documents requires
% the use of the "-t landscape" command line option to "dvips".

\\documentclass[landscape,letterpaper]{slides}
\\usepackage{epsfig}
\\setlength\\headheight{0pt}
\\setlength\\headsep   {0pt}
\\setlength\\topskip   {0pt}

\\begin{document}
 
\\pagestyle{empty}  % If you remove this line, your slides will have
                   % page numbers on them.

EOM

while (<>) {
    chop;
    if (/^\+\+/) {
	foreach ($i = 0; $i < $curlevel; $i++) {
	    print "\\end{itemize}\n";
	}
	print "\\end{slide}\n\n" if $inslide;
	s/^\+\+\s*//;
	print "\\begin{slide}{\\bf $_}\n";
	$inslide = 1;
	$curlevel = 0;
	next;
    }
    undef($level);
    if (/^(\*+)/) {
	$level = length($1);
	s/^\*+//;
    }
    if (defined($level) && $level > $curlevel) {
	foreach ($i = 0; $i < $level - $curlevel; $i++) {
	    print "\\begin{itemize}\n";
	}
	print "\\item $_\n";
	$curlevel = $level;
	next;
    } elsif (defined($level) && $level < $curlevel) {
	foreach ($i = 0; $i < $curlevel - $level; $i++) {
	    print "\\end{itemize}\n";
	}
	print "\\item $_\n";
	$curlevel = $level;
	next;
    } elsif (defined($level)) {
	print "\\item $_\n";
	next;
    }
    if (/^\-\-/) {
	foreach ($i = 0; $i < $curlevel; $i++) {
	    print "\\end{itemize}\n";
	}
	s/^\-\-\s*//;
	$curlevel = 0;
	print;
	print "\n";
	next;
    }
    print;
    print "\n";
}

foreach ($i = 0; $i < $curlevel; $i++) {
    print "\\end{itemize}\n";
}
print "\\end{slide}\n\n" if $inslide;
print "\\end{document}\n";
