
-module(simple0_test).
-define(DRV, simple0_drv).

-export([regression/0, filecopy/2]).

regression() ->
    {ok, Port} = ?DRV:start(),
    {ok, 1} = ?DRV:debug(Port, 1),
    r1(Port),
    io:format("All regression tests PASSED.\n"),
    ok.

r1(P) ->

    S1 = 10,
    io:format("\n\n VM will freeze ... sleep(~w) ...", [S1]),
    {ok, _} = ?DRV:sleep(P, S1),
    io:format("\n\n VM should be responsive ... asleep(~w) ...", [S1]),
    {ok, _} = ?DRV:asleep(P, S1),

    S2 = 15,
    io:format("\n\n VM will freeze ... sleep(~w) ...", [S2]),
    {ok, _} = ?DRV:sleep(P, S2),
    io:format("\n\n VM should be responsive ... asleep(~w) ...", [S2]),
    {ok, _} = ?DRV:asleep(P, S2),

    ok.

filecopy(Src, Dst) ->
    {ok, Rd} = file:open(Src, [read, binary]),
    {ok, Wr} = file:open(Dst, [write, binary]),
    RFun = fun () -> 
        file:read(Rd, 8192) end,
    WFun = fun (B) ->
	file:write(Wr, B) end,
    Val = filecopy2(RFun, WFun),
    io:format("\n"),
    Val.

filecopy2(RFun, WFun) ->
    filecopy2(RFun, WFun, RFun()).
filecopy2(RFun, WFun, {ok, B}) ->
    WFun(B),
    io:format("w"),
    filecopy2(RFun, WFun);
filecopy2(RFun, WFun, eof) ->
    ok;                 % End of file
filecopy2(RFun, WFun, Error) ->
    Error.

