
-module(spread_test).
-define(DRV, spread_drv).

-export([regression/0]).

regression() ->
    {ok, Port} = ?DRV:start(),
    pathetic_smoke_coverage(Port),
    ?DRV:shutdown(Port),
    io:format("All regression tests PASSED.\n"),
    ok.

pathetic_smoke_coverage(P) ->
    {ok, PrivName} = ?DRV:sp_connect(P, "", "erl1", 1, 1),
    {ok, 0} = ?DRV:sp_join(P, "foo"),
    {ok, 0} = ?DRV:sp_leave(P, "foo"),
    {ok, 0} = ?DRV:sp_leave(P, "foofoo"),
    {error, -14} = ?DRV:sp_leave(P, "foo#bad"),
    {ok, 13} = ?DRV:sp_multicast(P, 1, "foo", 42, "Hello, world!"),
    {ok, _} = ?DRV:sp_poll(P),
    {ok, _} = ?DRV:sp_receive(P, 4, 400),
    {ok, _} = ?DRV:sp_receive(P, 4, 400),
    %% There should be nothing to receive now
    {ok, 0} = ?DRV:sp_poll(P),

    ok.
